/*
 * Copyright 2014 Mirantis, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain
 * a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
**/
define([
    // dependency on jQuery is still needed because:
    // 1) we still have some Backbone code which uses $().i18n()
    // 2) it seems to be impossible to use AMD version with jQuery extensions
    'jquery',
    'underscore',
    'i18next',
    'json!translations/core.json'
], function($, _, i18next, translations) {
    'use strict';

    i18next.init({resStore: translations, fallbackLng: 'en-US'});

    // export global i18n variable to use in templates
    var i18n = window.i18n = i18next.t;

    return i18n;
});
